unit test;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    fen: TEdit;
    ButtonFen: TButton;
    Button2: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Button1: TButton;
    Button3: TButton;
    Label3: TLabel;
    ListBox1: TListBox;
    Button4: TButton;
    Memo1: TMemo;
    Button5: TButton;
    e1: TEdit;
    Label4: TLabel;
    procedure Button5Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ButtonFenClick(Sender: TObject);
  //procedure read_winboard;
  private
    { Private declarations }
  public
    { Public declarations }
    Wnd_OUT,Wnd_INPUT,AHandle: HWnd;
 Threadid:DWORD;
  end;

var
  Form1: TForm1;

 WP: array [0..5]  of  UInt64;
 BP: array [0..5]  of  UInt64;
 FName,StrMoves:string;
 go,runconsole:boolean;
 color:integer;
 //k:integer;
 UCIcommand: array [0..13]  of  string;
  MaskOneBit: array [0..63]  of  UInt64 = (
  1,2,4,8,16,32,64,128,256,512,1024,2048,4096,8192,16384,32768,65536,131072,262144,
  524288,1048576,2097152,4194304,8388608,16777216,33554432,67108864,134217728,
  268435456,536870912,1073741824,2147483648,4294967296,8589934592,17179869184,
  34359738368,68719476736,137438953472,274877906944,549755813888,1099511627776,
  2199023255552,4398046511104,8796093022208,17592186044416,35184372088832,
  70368744177664,140737488355328,281474976710656,562949953421312,1125899906842624,
  2251799813685248,4503599627370496,9007199254740992,18014398509481984,36028797018963968,
  72057594037927936,144115188075855872,288230376151711744,576460752303423488,
  1152921504606846976,2305843009213693952,4611686018427387904,9223372036854775808);
function searshMat2MoveFen(FenPos:string;Col,d:integer):string;stdcall;external 'Mat2Move.dll';
function  searshMat2MoveStr(sw,sb:string;Col:integer):string;stdcall;external 'Mat2Move.dll';
function  returnNewPosPiece(Color,i: Integer):UInt64;stdcall;external 'Mat2Move.dll';
function  setPosStrToU64(sw,sb:string):boolean;stdcall;external 'Mat2Move.dll';
function  setPosFenToU64(FenPos:string):boolean;stdcall;external 'Mat2Move.dll';
function  retutnVariant():string;stdcall;external 'Mat2Move.dll';
function  AllAttack(WP,BP: array of  UInt64;OB:UInt64;Color: Integer;UnMove:Boolean):UInt64;stdcall;external 'MoveGenerator.dll';
function  returnOneMove(Color,i: Integer):UInt64;stdcall;external 'MoveGenerator.dll';
function  returnOnePiece(Color,i: Integer):UInt64;stdcall;external 'MoveGenerator.dll';
function U64ToStr(s:string;AP:array  of UInt64):string;stdcall;external 'Mat2Move.dll';
procedure NewPosView(WP,BP:array of  UInt64;col:integer);stdcall;external 'VisualBoard.dll';
function ViewBoard(WP,BP:array of  UInt64;col:integer):boolean;stdcall;external 'VisualBoard.dll';
function returnNumLeavesTree():integer;stdcall;external 'Mat2Move.dll';
function setPMove():boolean;stdcall;external 'MakeMove.dll';
procedure setStop();stdcall;external 'Mat2Move.dll';
procedure setdepth(n:integer);stdcall;external 'VisualBoard.dll';
procedure initEvalute1;stdcall;external 'evalute1.dll';//
procedure viewEvalute1;stdcall;external 'evalute1.dll';//
function SToN(s:String):integer;stdcall;external 'Mat2Move.dll';
function returnStrMove():String;stdcall;external 'MakeMove.dll';
function U64toFen(WP,BP:array  of  UInt64;col:Integer):WideString;stdcall;external 'Mat2Move.dll';
function returnPlaceOnePiece(col,i:Integer):UInt64;stdcall;external 'MakeMove.dll';
procedure MovePiceFromTo (WP,BP:array  of  UInt64;fromBox,ToBox:UInt64;col,NPawnHi: Integer;analiz:Boolean);stdcall;external 'MakeMove.dll';
implementation

uses evalute_1;//

{$R *.dfm}
procedure WriteToFile(s:string;flag:Integer);
var
F: TextFile;
begin
//exit;
  try
          AssignFile(F, ExtractFilePath(Application.ExeName)+'LogUCI.TXT');{   }
       case flag of
           0:Rewrite(F); {      ,   }
           1:Append(F);
       end;
          Write(F,s);
  finally

    CloseFile(F);
  end;
end;
function FenToVisual(sfen:String):String;
var
f:array [0..6] of Integer;
strN,strF,s01,svis:string;
i,j,k,num,n,p:Integer;
begin 
with Form1.Label3 do begin
   Height:=180;
   Width:=180;
   if not runconsole then begin
      Align := alBottom;
      Alignment := taCenter;
   end;

   AutoSize := False;
   Layout := tlCenter;
   WordWrap := True;
   Font.Name:= 'gc2004d';
   Font.Size:=14;
end;

f[1]:=48;
f[2]:=71;
f[3]:=87;
f[4]:=109;
f[5]:=169;
f[6]:=185;
f[0]:=163;
   strN:='12345678';
   strF:='KQRBNPkqrbnp';
   k:=length(sfen);
   n:=0;num:=0;p:=0;
   svis:='';
   for i := 1 to k do begin
     s01:=copy(sfen,i,1);
     if s01=' ' then  break;
     if s01='/' then begin
       if p<>8 then  begin
       Form1.Label3.Font.Name:='Arial';
       result:=' FEN ';
       exit;
       end;
     p:=0;
     svis:=svis+#13#10;
            case n of
               0:n:=1;
               1:n:=0;
             end;
     continue;
     end;
     num:=pos(s01,strN);
     if num>0 then begin
         for j := 1 to num do begin
         svis:=svis+chr(f[0]+n);
         p:=p+1;
            case n of
               0:n:=1;
               1:n:=0;
             end;
         end;
     end;
     num:=pos(s01,strF);
          if num>0 then begin
            p:=p+1;
            if num>6 then  begin
               svis:=svis+chr(f[num-6]+n+2);
            end else begin
               svis:=svis+chr(f[num]+n);
            end;
             case n of
               0:n:=1;
               1:n:=0;
             end;
         end;
   end;
 result:=svis;
end;
procedure TForm1.ButtonFenClick(Sender: TObject);
var
i,d:integer;
begin
viewEvalute1();//
setPMove();
 label1.Caption:='0';
 setPosFenToU64(test.Form1.fen.Text);
 for i := 0 to 5 do  begin
  WP[i]:=returnNewPosPiece(0,i);
  BP[i]:=returnNewPosPiece(1,i);
 end;
   if Pos(' 2 ',test.Form1.fen.Text)>0 then d:=6;
   if Pos(' 3 ',test.Form1.fen.Text)>0 then d:=8;
   if Pos(' 4 ',test.Form1.fen.Text)>0 then d:=10;
  setdepth(d);  
 NewPosView(WP,BP,0);
 button1.Enabled:=true;
 button2.Enabled:=true;
 button3.Enabled:=true;
end;
function setPos(s3:string):widestring;
var
    strF,s01,s02:string;
    j,z,n,k,num:integer;
    ToFrom,FromTo:integer;
begin
strF:='qrbn';
s01:='';
k:=length(s3);
num:=1;
//FromTo:=0;ToFrom:=0;
               for j := 1 to k do begin
                 s02:=copy(s3,j,1);
                 if s02=' ' then begin
                    // 
if FromTo=-1 then begin
ShowMessage('');break;
end;
if ToFrom=-1 then begin
ShowMessage('');break;
end;
AllAttack(WP,BP,MaskOneBit[FromTo],color,true);
MovePiceFromTo(WP,BP,MaskOneBit[FromTo],MaskOneBit[ToFrom],color,num,true);
for z := 0 to 5 do begin// 
  WP[z]:=returnPlaceOnePiece(0,z);
  BP[z]:=returnPlaceOnePiece(1,z);
end;
   if j<>k then begin
           case color of
             0:begin
                color:=1;
               end;
              1:begin
                color:=0;
              end;
            end;//case
   end;
 s01:='';
 continue;
                 end;// if s02=' '
                 s01:=s01+s02;
                 if length(s01)=5 then begin
                 num:=pos(s02,strF);
                    if num>0 then begin
                       s01:='';
                       continue;
                    end;
                 end;//if
                 if length(s01)=4 then begin
                   //  
                 FromTo:=SToN(copy(s01,1,2));
                 ToFrom:=SToN(copy(s01,3,2));
                 end;//if
               end;//for j
result:=U64toFen(WP,BP,color);

end;


procedure send_winboard(var msg:string); // send your own move
var len:cardinal;
    x:pChar;
    b:byte;
begin
   len:=length(msg);
   x:=pchar(msg+#10); // just to be safe
   //b:=_lwrite(Form1.Wnd_OUT,x,len+1);
   WriteToFile('<id=alexlaw >'+x,1);
    write(output,x);
   //ShowMessage(IntToStr(b));
end;
procedure read_winboard;  // do the actual reading
var tekst,s,s1,s2,s3:string;
    ch:char;
    i,j,n:integer;
begin
 Form1.Memo1.WordWrap:=true;
 
   while true do
   begin
       tekst:='';
      repeat
          if not runconsole then begin  
               exit;
          end;
         read(input,ch);
         tekst:=tekst+ch;
      until ch=#10;
     WriteToFile('<winboard >'+tekst,1);
      s:=s+#13#10+tekst;
      Form1.Memo1.Text:=s;
for i := 0 to 12 do  begin
   n:=pos(UCIcommand[i],tekst);
      if n>0 then begin
         case i of
            0:begin //uci
         s:='id name chump';
         send_winboard(s);
         s:='id author alexlaw';
         send_winboard(s);
         s:='uciok';
         send_winboard(s);
            end;
            1:begin //isready
         s:='readyok';
         send_winboard(s);
            end;
            2:begin //go
            go:=true;
            end;
            3:begin //position

            end;
            4:begin //fen
            //if go then continue;
             s1:=copy(tekst,n+3,length(tekst)-n);
             s1:=TrimLeft(s1);
             for j := 1 to length(s1) do begin
                 if copy(s1,j,1)=' ' then begin
                   s2:=Trim(copy(s1,j,length(s1)-j));
                   s1:=copy(s1,1,j);
                   break;
                 end;
             end;
   //test.Form1.fen.Text:=s2;
  setPosFenToU64(s1);
 for j := 0 to 5 do  begin
  WP[j]:=returnNewPosPiece(0,j);
  BP[j]:=returnNewPosPiece(1,j);
 end;
 color:=0;
 test.Form1.Label3.Caption:=FenToVisual(s1);
            end;
            5,7:begin //startpos, ucinewgame
            //if go then continue;
             if i=7 then  begin
             StrMoves:='';
              color:=0;
             end;
             s1:='rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR';
             test.Form1.Label3.Caption:=FenToVisual(s1);
  setPosFenToU64(s1);
 for j := 0 to 5 do  begin
  WP[j]:=returnNewPosPiece(0,j);
  BP[j]:=returnNewPosPiece(1,j);
 end;
 color:=0;
 test.Form1.Label3.Caption:=FenToVisual(s1);
            end;
            6:begin //moves_   c2c4 e7e6 b1c3 d7d5 c4d5
s3:=Trim(copy(tekst,n+6,length(tekst)-n))+' ';
StrMoves:=s3;
test.Form1.fen.Text:=StrMoves;
s2:=setPos(StrMoves);
// s2:=U64toFen(WP,BP,color);
 test.Form1.Label3.Caption:=FenToVisual(s2);
            end;
            8:begin //debug

            end;
            9:begin

            end;
            10:begin

            end;
            11:begin //stop
            go:=false;

            end;
            12:begin //quit
            go:=false;
            runconsole:=false;
            end;
         end; //case
      end;//if n>0

 end;//for i
   end;//while true
//FreeConsole;
end;
procedure TForm1.FormCreate(Sender: TObject);
var
s:string;
j:integer;
begin
   //AllocConsole; debug
   runconsole:=false;
   if ParamCount>0 then begin
     if ParamStr(1)='uci' then begin
       runconsole:=true;
       Form1.Memo1.Visible:=true;
       Form1.e1.Visible:=true;
       Form1.Button5.Visible:=true;
         button1.Enabled:=false;
         button2.Enabled:=false;
         button3.Enabled:=false;
         ButtonFen.Enabled:=false;
         ListBox1.Enabled:=false;
         test.Form1.Label4.Visible:=true;
     end;

   end;
  go:=false;
 StrMoves:=''; 
  UCIcommand[0]:='uci';
{    uci.
,      ,
    ,     uci-.
   "uci"    
   "id"    GUI   "option",
  ,    .
      "uciok".
        ,
 GUI   . }
  UCIcommand[1]:='isready';
{ ,  ,     .
   , ,   ,
     .
      ,    .
      "readyok",     .
         "readyok",
     . }
  UCIcommand[2]:='go';
  UCIcommand[3]:='position';
 {position [fen #fenstring | startpos ] moves #move1 .... #movei
     .
      .
   :
      ,
    #move1, #move2, ..., #movei.
    (  "startpos"),
   #fenstring,    fen
(  fen #fenstring).
: "position startpos moves e2e4 e7e5 b1c3"
  "startpos"  .  GUI     .}
  UCIcommand[4]:='fen';
  UCIcommand[5]:='startpos';
  UCIcommand[6]:='moves ';
  UCIcommand[7]:='ucinewgame';
  UCIcommand[8]:='debug';
  UCIcommand[9]:='on';
  UCIcommand[10]:='off';
  UCIcommand[11]:='stop';
  {        .
       "bestmove" }
  UCIcommand[12]:='quit';
  {   . }
   AddFontResource('gc2004d_.ttf');
   SendMessage(HWND_BROADCAST, WM_FONTCHANGE, 0, 0);
  try
    //AllocConsole;
    //SetConsoleTitle( PChar( 'test1.exe'));
if runconsole then   begin
    WriteToFile('',0);
end;
    Form1.Wnd_OUT:= GetStdHandle( STD_OUTPUT_HANDLE );
    Form1.Wnd_INPUT:= GetStdHandle( STD_INPUT_HANDLE );
    Form1.AHandle:=BeginThread(nil,0,@read_winboard,nil,0,Threadid);

FName:=ExtractFilePath(Application.ExeName)+'fen.TXT';
 if FileExists(FName) then begin
   ListBox1.Items.LoadFromFile(FName);
   ListBox1.ItemIndex:=0;
 end else begin
 ShowMessage(' fen.txt  ');
 ListBox1.Items[0]:='rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR w - - 0 1';
 end;
  finally
s:=ListBox1.Items[0];
test.Form1.fen.Text:=s;
Label3.Caption:=FenToVisual(s);

  end;
end;

procedure TForm1.FormDestroy(Sender: TObject);
var
s:string;
begin
 RemoveFontResource('gc2004d_.ttf');
 SendMessage(HWND_BROADCAST, WM_FONTCHANGE, 0, 0);
   try
 TerminateThread(Form1.AHandle,0);
 CloseHandle(Form1.AHandle);
 CloseHandle(Form1.Wnd_OUT);
 CloseHandle(Form1.Wnd_INPUT);
   finally

   end;
end;

procedure TForm1.ListBox1Click(Sender: TObject);
var
k:integer;
s:string;
begin
 button1.Enabled:=false;
 button2.Enabled:=false;
 button3.Enabled:=false;
 k:=ListBox1.ItemIndex;
 if k<0 then k:=0;
 s:=ListBox1.Items[k];
test.Form1.fen.Text:=s; 
Label3.Caption:=FenToVisual(s);
end;

procedure TForm1.Button1Click(Sender: TObject);
var
s1:string;
begin
 form1.ButtonFenClick(Sender);
 button1.Enabled:=false;
 button2.Enabled:=false;
 button3.Enabled:=false;
 // WriteLn( DateTimeToStr(Now));
 s1:=searshMat2MoveFen(test.Form1.fen.Text,0,6);
  WriteLn( DateTimeToStr(Now));
 if s1='-' then NewPosView(WP,BP,0);
 //s2:=retutnVariant();
 ShowMessage(s1);
label1.Caption:=IntToStr(returnNumLeavesTree);
end;

procedure TForm1.Button2Click(Sender: TObject);
var
s1:string;
begin
 form1.ButtonFenClick(Sender);
 button1.Enabled:=false;
 button2.Enabled:=false;
 button3.Enabled:=false;
 s1:=searshMat2MoveFen(test.Form1.fen.Text,0,4);
 if s1='-' then NewPosView(WP,BP,0);
 //s2:=retutnVariant();
 ShowMessage(s1);
label1.Caption:=IntToStr(returnNumLeavesTree);
end;
procedure TForm1.Button3Click(Sender: TObject);
var
s1:string;
begin
 form1.ButtonFenClick(Sender);
 button1.Enabled:=false;
 button2.Enabled:=false;
 button3.Enabled:=false; 
 s1:=searshMat2MoveFen(test.Form1.fen.Text,0,8);
 if s1='-' then NewPosView(WP,BP,0);
 //s2:=retutnVariant();
 ShowMessage(s1);
label1.Caption:=IntToStr(returnNumLeavesTree);
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
 setStop();
end;

procedure TForm1.Button5Click(Sender: TObject);
var
s:string;
j:integer;
ToFrom,FromTo:integer;
MP:UInt64;
begin
if go then begin
setPos(StrMoves);
  s:=e1.Text;
  FromTo:=SToN(copy(s,1,2));
  ToFrom:=SToN(copy(s,3,2));
  if FromTo=-1 then exit;
  if ToFrom=-1 then exit;
//  MP:=AllAttack(WP,BP,MaskOneBit[FromTo],color,false);
//  if (MP and MaskOneBit[ToFrom])=0 then exit;
setPos(StrMoves+s+' ');
  Label3.Caption:=FenToVisual(U64toFen(WP,BP,color));
  s:='bestmove ' + s;
  send_winboard(s);
  e1.Text:='';
end else begin

end;
end;

end.
